//+------------------------------------------------------------------+
//|                                                          _HL.mq4 |
//|                                            Copyright 2012, Vinin |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, Vinin"
#property link      "vinin@mail.ru"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Yellow
#property indicator_color2 Yellow
#property indicator_color3 Yellow
#property indicator_color4 Green
#property indicator_color5 Red
#property indicator_width3 1
#property indicator_width4 2
#property indicator_width5 2
//--- input parameters
extern int       Period_1=6;
extern int       Period_2=48;
//--- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double K1, K2;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE); SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE); SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE); SetIndexBuffer(2,ExtMapBuffer3); SetIndexEmptyValue(3,EMPTY_VALUE);
   SetIndexStyle(3,DRAW_LINE); SetIndexBuffer(3,ExtMapBuffer4); SetIndexEmptyValue(3,EMPTY_VALUE);
   SetIndexStyle(4,DRAW_LINE); SetIndexBuffer(4,ExtMapBuffer5); SetIndexEmptyValue(3,EMPTY_VALUE);
   
   K1=2.0/(Period_1+1.0);
   K2=2.0/(Period_2+1.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   double tmp;
   int limit=Bars-counted_bars;
   if (limit>1) {
      limit=Bars-2;
      ExtMapBuffer1[Bars-1]=High[Bars-1];
      ExtMapBuffer2[Bars-1]=Low[ Bars-1];
      ExtMapBuffer3[Bars-1]=(High[Bars-1]+Low[ Bars-1])*0.5;
   }
   for (int i=limit;i>=0;i--) {
      if (High[i]>ExtMapBuffer1[i+1]) {
         ExtMapBuffer1[i]=High[i]*K1+ExtMapBuffer1[i+1]*(1.0-K1);
      } else {
         ExtMapBuffer1[i]=High[i]*K2+ExtMapBuffer1[i+1]*(1.0-K2);
      }
      if (Low[i]<ExtMapBuffer2[i+1]) {
         ExtMapBuffer2[i]=Low[i]*K1+ExtMapBuffer2[i+1]*(1.0-K1);
      } else {
         ExtMapBuffer2[i]=Low[i]*K2+ExtMapBuffer2[i+1]*(1.0-K2);
      }
      ExtMapBuffer3[i]=(ExtMapBuffer1[i]+ExtMapBuffer2[i])*0.5;
      ExtMapBuffer4[i]=EMPTY_VALUE;
      ExtMapBuffer5[i]=EMPTY_VALUE;



      if ((ExtMapBuffer1[i]-ExtMapBuffer2[i])-(ExtMapBuffer1[i+1]-ExtMapBuffer2[i+1]>0)) {
         if (ExtMapBuffer3[i]>ExtMapBuffer3[i+1]) {
            ExtMapBuffer4[i]=ExtMapBuffer3[i];
            ExtMapBuffer4[i+1]=ExtMapBuffer3[i+1];
         } else {
            ExtMapBuffer5[i]=ExtMapBuffer3[i];
            ExtMapBuffer5[i+1]=ExtMapBuffer3[i+1];
         }
      }
      
      
   }
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+